{
    This file is part of the Free Pascal run time library.
    Copyright (c) 1999-2000 by Michael Van Canneyt,
    member of the Free Pascal development team.

    Signal handler is arch dependant due to processor to language
    exception conversion.

    See the file COPYING.FPC, included in this distribution,
    for details about the copyright.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

 **********************************************************************}

{ $define SYSTEM_DEBUG}

procedure SignalToRunerror(Sig: longint; SigInfo: PSigInfo; UContext: PUContext); public name '_FPC_DEFAULTSIGHANDLER'; cdecl;

const
  used_fp = 1 shl 0;
  adrerr_rd = 1 shl 30;
  adrerr_wr = 1 shl 31;
  fcsr_bits_clear_exceptions = $e0ffffff;

var
  res : word;
  ferr: cUint;

begin
  res:=0;
  ferr:=0;
  case sig of
    SIGFPE:
      begin
        res:=207;
        if (used_fp and UContext^.uc_mcontext.flags)<>0 then
          begin
            ferr:=UContext^.uc_mcontext.fcsr;
            UContext^.uc_mcontext.fcsr:= UContext^.uc_mcontext.fcsr and fcsr_bits_clear_exceptions;
            ferr:=ferr shr 24;
            case ferr of
              { Inexact Underflow Overflow dividebyZero inValid systemh.inc }
              1: res:=207;
              2: res:=206;
              4: res:=205;
              8: res:=208;
              16: res:=207;
            else
              ;
            end;
          end;

      end;
    SIGILL:
        res:=216;
    SIGSEGV :
		begin
        res:=216;
		end;
    SIGBUS:
        res:=214;
    SIGINT:
        res:=217;
    SIGQUIT:
        res:=233;
  end;
  reenable_signal(sig);
  { give runtime error at the position where the signal was raised }
  if res<>0 then
    HandleErrorAddrFrame(res,
      pointer(uContext^.uc_mcontext.pc),
      pointer(uContext^.uc_mcontext.regs[3]));
end;
