{
    This file is part of the Free Pascal run time library.
    Copyright (c) 1999-2000 by Jonas Maebe,
    member of the Free Pascal development team.

    TSigContext and associated structures.

    See the file COPYING.FPC, included in this distribution,
    for details about the copyright.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

 **********************************************************************}

{$packrecords C}

type

  {uapi/asm/sigcontext.h}
  PSigContext = ^TSigContext;
  TSigContext = record
    pc : cULong;
    regs : array[0..31] of cULong;
    flags : cUInt;
	fcsr :cUInt;
	vcsr :cUInt;
        __padding : cInt;
	fcc  :cULong;
	scr  :array[0..3] of cULong;
	{aligned(32)}
        fpregs : array[0..31] of record
            case longint of
              0 : ( val32 : array[0..7] of cUInt);
              1 : ( val64 : array[0..3] of cULong);
            end;
	   { The following fields should be 16-byte-aligned. Currently the
	   directive for specifying alignment is buggy, so the preceding
	   field was added so that the record has the right size. }
	{aligned(16)}
	__reserved : array[0..4095] of byte;
  end;

  stack_t = record
    ss_sp : pointer;
    ss_flags : cInt;
    __padding : cInt;
    ss_size : Int64;
  end;

  PUContext = ^TUContext;
  TUContext = record
    uc_flags : cULong;
    uc_link : PUContext;
    uc_stack : stack_t;
    __padding : array[0..2] of cULong;
    uc_mcontext : TSigContext;
    uc_sigmask : sigset_t;
    { __padding : array[1..128 - sizeof(sigset_t)] of byte; }
    __pad3 : array[1..112] of byte;
  end;
